t0001: fix on case-insensitive filesystems
[git/git.git] / t / test-lib-functions.sh
CommitLineData
c74c7203
JN
1# Library of functions shared by all tests scripts, included by
2# test-lib.sh.
12a29b1a
TR
3#
4# Copyright (c) 2005 Junio C Hamano
5#
6# This program is free software: you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation, either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see http://www.gnu.org/licenses/ .
18
19# The semantics of the editor variables are that of invoking
20# sh -c "$EDITOR \"$@\"" files ...
21#
22# If our trash directory contains shell metacharacters, they will be
23# interpreted if we just set $EDITOR directly, so do a little dance with
24# environment variables to work around this.
25#
26# In particular, quoting isn't enough, as the path may contain the same quote
27# that we're using.
28test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33}
34
5d9fc888
TG
35test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38}
39
12a29b1a
TR
40test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
991eb4fc
SB
45 if (n == 2) return "FAINT";
46 if (n == 3) return "ITALIC";
097b681b 47 if (n == 7) return "REVERSE";
12a29b1a
TR
48 if (n == 30) return "BLACK";
49 if (n == 31) return "RED";
50 if (n == 32) return "GREEN";
51 if (n == 33) return "YELLOW";
52 if (n == 34) return "BLUE";
53 if (n == 35) return "MAGENTA";
54 if (n == 36) return "CYAN";
55 if (n == 37) return "WHITE";
56 if (n == 40) return "BLACK";
57 if (n == 41) return "BRED";
58 if (n == 42) return "BGREEN";
59 if (n == 43) return "BYELLOW";
60 if (n == 44) return "BBLUE";
61 if (n == 45) return "BMAGENTA";
62 if (n == 46) return "BCYAN";
63 if (n == 47) return "BWHITE";
64 }
65 {
66 while (match($0, /\033\[[0-9;]*m/) != 0) {
67 printf "%s<", substr($0, 1, RSTART-1);
68 codes = substr($0, RSTART+2, RLENGTH-3);
69 if (length(codes) == 0)
70 printf "%s", name(0)
71 else {
72 n = split(codes, ary, ";");
73 sep = "";
74 for (i = 1; i <= n; i++) {
75 printf "%s%s", sep, name(ary[i]);
76 sep = ";"
77 }
78 }
79 printf ">";
80 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81 }
82 print
83 }
84 '
85}
86
b249e39f
JH
87lf_to_nul () {
88 perl -pe 'y/\012/\000/'
89}
90
12a29b1a 91nul_to_q () {
94221d22 92 perl -pe 'y/\000/Q/'
12a29b1a
TR
93}
94
95q_to_nul () {
94221d22 96 perl -pe 'y/Q/\000/'
12a29b1a
TR
97}
98
99q_to_cr () {
100 tr Q '\015'
101}
102
103q_to_tab () {
104 tr Q '\011'
105}
106
250b3c6c
JH
107qz_to_tab_space () {
108 tr QZ '\011\040'
12a29b1a
TR
109}
110
111append_cr () {
112 sed -e 's/$/Q/' | tr Q '\015'
113}
114
115remove_cr () {
116 tr '\015' Q | sed -e 's/Q$//'
117}
118
b0fa1a3f
RB
119# Generate an output of $1 bytes of all zeroes (NULs, not ASCII zeroes).
120# If $1 is 'infinity', output forever or until the receiving pipe stops reading,
121# whichever comes first.
122generate_zero_bytes () {
d5cfd142 123 test-tool genzeros "$@"
b0fa1a3f
RB
124}
125
12a29b1a
TR
126# In some bourne shell implementations, the "unset" builtin returns
127# nonzero status when a variable to be unset was not set in the first
128# place.
129#
130# Use sane_unset when that should not be considered an error.
131
132sane_unset () {
133 unset "$@"
134 return 0
135}
136
137test_tick () {
138 if test -z "${test_tick+set}"
139 then
140 test_tick=1112911993
141 else
142 test_tick=$(($test_tick + 60))
143 fi
144 GIT_COMMITTER_DATE="$test_tick -0700"
145 GIT_AUTHOR_DATE="$test_tick -0700"
146 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
147}
148
59210dd5 149# Stop execution and start a shell. This is useful for debugging tests.
12a29b1a
TR
150#
151# Be sure to remove all invocations of this command before submitting.
152
153test_pause () {
59210dd5 154 "$SHELL_PATH" <&6 >&5 2>&7
12a29b1a
TR
155}
156
84243646
EN
157# Wrap git with a debugger. Adding this to a command can make it easier
158# to understand what is going on in a failing test.
6a94088c 159#
84243646
EN
160# Examples:
161# debug git checkout master
162# debug --debugger=nemiver git $ARGS
163# debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
6a94088c 164debug () {
84243646
EN
165 case "$1" in
166 -d)
167 GIT_DEBUGGER="$2" &&
168 shift 2
169 ;;
170 --debugger=*)
171 GIT_DEBUGGER="${1#*=}" &&
172 shift 1
173 ;;
174 *)
175 GIT_DEBUGGER=1
176 ;;
177 esac &&
178 GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
6a94088c
JS
179}
180
6f94351b
SB
181# Call test_commit with the arguments
182# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
12a29b1a
TR
183#
184# This will commit a file with the given contents and the given commit
4c994194 185# message, and tag the resulting commit with the given tag name.
12a29b1a 186#
4c994194 187# <file>, <contents>, and <tag> all default to <message>.
6f94351b
SB
188#
189# If the first argument is "-C", the second argument is used as a path for
190# the git invocations.
12a29b1a
TR
191
192test_commit () {
9a0231b3 193 notick= &&
5ed75e2a 194 signoff= &&
6f94351b 195 indir= &&
5ed75e2a
MV
196 while test $# != 0
197 do
198 case "$1" in
199 --notick)
200 notick=yes
201 ;;
202 --signoff)
203 signoff="$1"
204 ;;
6f94351b
SB
205 -C)
206 indir="$2"
207 shift
208 ;;
5ed75e2a
MV
209 *)
210 break
211 ;;
212 esac
9a0231b3 213 shift
5ed75e2a 214 done &&
6f94351b 215 indir=${indir:+"$indir"/} &&
9a0231b3 216 file=${2:-"$1.t"} &&
6f94351b
SB
217 echo "${3-$1}" > "$indir$file" &&
218 git ${indir:+ -C "$indir"} add "$file" &&
9a0231b3
JH
219 if test -z "$notick"
220 then
221 test_tick
222 fi &&
6f94351b
SB
223 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
224 git ${indir:+ -C "$indir"} tag "${4:-$1}"
12a29b1a
TR
225}
226
227# Call test_merge with the arguments "<message> <commit>", where <commit>
228# can be a tag pointing to the commit-to-merge.
229
230test_merge () {
231 test_tick &&
232 git merge -m "$1" "$2" &&
233 git tag "$1"
234}
235
236# This function helps systems where core.filemode=false is set.
237# Use it instead of plain 'chmod +x' to set or unset the executable bit
238# of a file in the working directory and add it to the index.
239
240test_chmod () {
241 chmod "$@" &&
242 git update-index --add "--chmod=$@"
243}
244
73de1c93
CC
245# Get the modebits from a file.
246test_modebits () {
247 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
248}
249
12a29b1a
TR
250# Unset a configuration variable, but don't fail if it doesn't exist.
251test_unconfig () {
5fafc07f
JK
252 config_dir=
253 if test "$1" = -C
254 then
255 shift
256 config_dir=$1
257 shift
258 fi
259 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
12a29b1a
TR
260 config_status=$?
261 case "$config_status" in
262 5) # ok, nothing to unset
263 config_status=0
264 ;;
265 esac
266 return $config_status
267}
268
269# Set git config, automatically unsetting it after the test is over.
270test_config () {
5fafc07f
JK
271 config_dir=
272 if test "$1" = -C
273 then
274 shift
275 config_dir=$1
276 shift
277 fi
278 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
279 git ${config_dir:+-C "$config_dir"} config "$@"
12a29b1a
TR
280}
281
282test_config_global () {
283 test_when_finished "test_unconfig --global '$1'" &&
284 git config --global "$@"
285}
286
287write_script () {
288 {
289 echo "#!${2-"$SHELL_PATH"}" &&
290 cat
291 } >"$1" &&
292 chmod +x "$1"
293}
294
295# Use test_set_prereq to tell that a particular prerequisite is available.
296# The prerequisite can later be checked for in two ways:
297#
298# - Explicitly using test_have_prereq.
299#
300# - Implicitly by specifying the prerequisite tag in the calls to
301# test_expect_{success,failure,code}.
302#
303# The single parameter is the prerequisite tag (a simple word, in all
304# capital letters by convention).
305
7d0ee47c
JS
306test_unset_prereq () {
307 ! test_have_prereq "$1" ||
308 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
309}
310
12a29b1a 311test_set_prereq () {
7d0ee47c
JS
312 case "$1" in
313 !*)
314 test_unset_prereq "${1#!}"
315 ;;
316 *)
317 satisfied_prereq="$satisfied_prereq$1 "
318 ;;
319 esac
12a29b1a 320}
f3cfc3b2 321satisfied_prereq=" "
04083f27
JH
322lazily_testable_prereq= lazily_tested_prereq=
323
324# Usage: test_lazy_prereq PREREQ 'script'
325test_lazy_prereq () {
326 lazily_testable_prereq="$lazily_testable_prereq$1 "
327 eval test_prereq_lazily_$1=\$2
328}
329
330test_run_lazy_prereq_ () {
331 script='
332mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
333(
334 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
335)'
336 say >&3 "checking prerequisite: $1"
337 say >&3 "$script"
338 test_eval_ "$script"
339 eval_ret=$?
340 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
341 if test "$eval_ret" = 0; then
342 say >&3 "prerequisite $1 ok"
343 else
344 say >&3 "prerequisite $1 not satisfied"
345 fi
346 return $eval_ret
347}
12a29b1a
TR
348
349test_have_prereq () {
350 # prerequisites can be concatenated with ','
351 save_IFS=$IFS
352 IFS=,
353 set -- $*
354 IFS=$save_IFS
355
356 total_prereq=0
357 ok_prereq=0
358 missing_prereq=
359
360 for prerequisite
361 do
bdccd3c1
JK
362 case "$prerequisite" in
363 !*)
364 negative_prereq=t
365 prerequisite=${prerequisite#!}
366 ;;
367 *)
368 negative_prereq=
369 esac
370
04083f27
JH
371 case " $lazily_tested_prereq " in
372 *" $prerequisite "*)
373 ;;
374 *)
375 case " $lazily_testable_prereq " in
376 *" $prerequisite "*)
377 eval "script=\$test_prereq_lazily_$prerequisite" &&
378 if test_run_lazy_prereq_ "$prerequisite" "$script"
379 then
380 test_set_prereq $prerequisite
381 fi
382 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
383 esac
384 ;;
385 esac
386
12a29b1a 387 total_prereq=$(($total_prereq + 1))
f3cfc3b2 388 case "$satisfied_prereq" in
12a29b1a 389 *" $prerequisite "*)
bdccd3c1
JK
390 satisfied_this_prereq=t
391 ;;
392 *)
393 satisfied_this_prereq=
394 esac
395
396 case "$satisfied_this_prereq,$negative_prereq" in
397 t,|,t)
12a29b1a
TR
398 ok_prereq=$(($ok_prereq + 1))
399 ;;
400 *)
bdccd3c1
JK
401 # Keep a list of missing prerequisites; restore
402 # the negative marker if necessary.
403 prerequisite=${negative_prereq:+!}$prerequisite
12a29b1a
TR
404 if test -z "$missing_prereq"
405 then
406 missing_prereq=$prerequisite
407 else
408 missing_prereq="$prerequisite,$missing_prereq"
409 fi
410 esac
411 done
412
413 test $total_prereq = $ok_prereq
414}
415
416test_declared_prereq () {
417 case ",$test_prereq," in
418 *,$1,*)
419 return 0
420 ;;
421 esac
422 return 1
423}
424
d93d5d51
JH
425test_verify_prereq () {
426 test -z "$test_prereq" ||
427 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
165293af 428 BUG "'$test_prereq' does not look like a prereq"
d93d5d51
JH
429}
430
12a29b1a 431test_expect_failure () {
ae75342c 432 test_start_
12a29b1a
TR
433 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
434 test "$#" = 2 ||
165293af 435 BUG "not 2 or 3 parameters to test-expect-failure"
d93d5d51 436 test_verify_prereq
12a29b1a
TR
437 export test_prereq
438 if ! test_skip "$@"
439 then
440 say >&3 "checking known breakage: $2"
441 if test_run_ "$2" expecting_failure
442 then
443 test_known_broken_ok_ "$1"
444 else
445 test_known_broken_failure_ "$1"
446 fi
447 fi
ae75342c 448 test_finish_
12a29b1a
TR
449}
450
451test_expect_success () {
ae75342c 452 test_start_
12a29b1a
TR
453 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
454 test "$#" = 2 ||
165293af 455 BUG "not 2 or 3 parameters to test-expect-success"
d93d5d51 456 test_verify_prereq
12a29b1a
TR
457 export test_prereq
458 if ! test_skip "$@"
459 then
460 say >&3 "expecting success: $2"
461 if test_run_ "$2"
462 then
463 test_ok_ "$1"
464 else
465 test_failure_ "$@"
466 fi
467 fi
ae75342c 468 test_finish_
12a29b1a
TR
469}
470
471# test_external runs external test scripts that provide continuous
472# test output about their progress, and succeeds/fails on
473# zero/non-zero exit code. It outputs the test output on stdout even
474# in non-verbose mode, and announces the external script with "# run
475# <n>: ..." before running it. When providing relative paths, keep in
476# mind that all scripts run in "trash directory".
477# Usage: test_external description command arguments...
478# Example: test_external 'Perl API' perl ../path/to/test.pl
479test_external () {
480 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
481 test "$#" = 3 ||
165293af 482 BUG "not 3 or 4 parameters to test_external"
12a29b1a
TR
483 descr="$1"
484 shift
d93d5d51 485 test_verify_prereq
12a29b1a
TR
486 export test_prereq
487 if ! test_skip "$descr" "$@"
488 then
489 # Announce the script to reduce confusion about the
490 # test output that follows.
491 say_color "" "# run $test_count: $descr ($*)"
492 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
493 # to be able to use them in script
494 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
495 # Run command; redirect its stderr to &4 as in
496 # test_run_, but keep its stdout on our stdout even in
497 # non-verbose mode.
498 "$@" 2>&4
9e8f8dea 499 if test "$?" = 0
12a29b1a
TR
500 then
501 if test $test_external_has_tap -eq 0; then
502 test_ok_ "$descr"
503 else
504 say_color "" "# test_external test $descr was ok"
505 test_success=$(($test_success + 1))
506 fi
507 else
508 if test $test_external_has_tap -eq 0; then
509 test_failure_ "$descr" "$@"
510 else
511 say_color error "# test_external test $descr failed: $@"
512 test_failure=$(($test_failure + 1))
513 fi
514 fi
515 fi
516}
517
518# Like test_external, but in addition tests that the command generated
519# no output on stderr.
520test_external_without_stderr () {
521 # The temporary file has no (and must have no) security
522 # implications.
523 tmp=${TMPDIR:-/tmp}
524 stderr="$tmp/git-external-stderr.$$.tmp"
525 test_external "$@" 4> "$stderr"
9e8f8dea 526 test -f "$stderr" || error "Internal error: $stderr disappeared."
12a29b1a
TR
527 descr="no stderr: $1"
528 shift
529 say >&3 "# expecting no stderr from previous command"
9e8f8dea
DA
530 if test ! -s "$stderr"
531 then
12a29b1a
TR
532 rm "$stderr"
533
534 if test $test_external_has_tap -eq 0; then
535 test_ok_ "$descr"
536 else
537 say_color "" "# test_external_without_stderr test $descr was ok"
538 test_success=$(($test_success + 1))
539 fi
540 else
9e8f8dea
DA
541 if test "$verbose" = t
542 then
543 output=$(echo; echo "# Stderr is:"; cat "$stderr")
12a29b1a
TR
544 else
545 output=
546 fi
547 # rm first in case test_failure exits.
548 rm "$stderr"
549 if test $test_external_has_tap -eq 0; then
550 test_failure_ "$descr" "$@" "$output"
551 else
552 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
553 test_failure=$(($test_failure + 1))
554 fi
555 fi
556}
557
558# debugging-friendly alternatives to "test [-f|-d|-e]"
559# The commands test the existence or non-existence of $1. $2 can be
560# given to provide a more precise diagnosis.
561test_path_is_file () {
9e8f8dea 562 if ! test -f "$1"
12a29b1a 563 then
de248e92 564 echo "File $1 doesn't exist. $2"
12a29b1a
TR
565 false
566 fi
567}
568
569test_path_is_dir () {
9e8f8dea 570 if ! test -d "$1"
12a29b1a 571 then
de248e92 572 echo "Directory $1 doesn't exist. $2"
12a29b1a
TR
573 false
574 fi
575}
576
7e9055bb
EN
577test_path_exists () {
578 if ! test -e "$1"
579 then
580 echo "Path $1 doesn't exist. $2"
581 false
582 fi
583}
584
0be7d9b7
JL
585# Check if the directory exists and is empty as expected, barf otherwise.
586test_dir_is_empty () {
587 test_path_is_dir "$1" &&
588 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
589 then
590 echo "Directory '$1' is not empty, it contains:"
591 ls -la "$1"
592 return 1
593 fi
594}
595
21d5ad91
RA
596# Check if the file exists and has a size greater than zero
597test_file_not_empty () {
598 if ! test -s "$1"
599 then
600 echo "'$1' is not a non-empty file."
601 false
602 fi
603}
604
12a29b1a 605test_path_is_missing () {
9e8f8dea 606 if test -e "$1"
12a29b1a
TR
607 then
608 echo "Path exists:"
609 ls -ld "$1"
9e8f8dea
DA
610 if test $# -ge 1
611 then
12a29b1a
TR
612 echo "$*"
613 fi
614 false
615 fi
616}
617
618# test_line_count checks that a file has the number of lines it
619# ought to. For example:
620#
621# test_expect_success 'produce exactly one line of output' '
622# do something >output &&
623# test_line_count = 1 output
624# '
625#
626# is like "test $(wc -l <output) = 1" except that it passes the
627# output through when the number of lines is wrong.
628
629test_line_count () {
630 if test $# != 3
631 then
165293af 632 BUG "not 3 parameters to test_line_count"
12a29b1a
TR
633 elif ! test $(wc -l <"$3") "$1" "$2"
634 then
635 echo "test_line_count: line count for $3 !$1 $2"
636 cat "$3"
637 return 1
638 fi
639}
640
bbfe5302
LS
641# Returns success if a comma separated string of keywords ($1) contains a
642# given keyword ($2).
643# Examples:
644# `list_contains "foo,bar" bar` returns 0
645# `list_contains "foo" bar` returns 1
646
647list_contains () {
648 case ",$1," in
649 *,$2,*)
650 return 0
651 ;;
652 esac
653 return 1
654}
655
12a29b1a
TR
656# This is not among top-level (test_expect_success | test_expect_failure)
657# but is a prefix that can be used in the test script, like:
658#
659# test_expect_success 'complain and die' '
660# do something &&
661# do something else &&
662# test_must_fail git checkout ../outerspace
663# '
664#
665# Writing this as "! git checkout ../outerspace" is wrong, because
666# the failure could be due to a segv. We want a controlled failure.
12e31a6b
SG
667#
668# Accepts the following options:
669#
670# ok=<signal-name>[,<...>]:
671# Don't treat an exit caused by the given signal as error.
672# Multiple signals can be specified as a comma separated list.
673# Currently recognized signal names are: sigpipe, success.
674# (Don't use 'success', use 'test_might_fail' instead.)
12a29b1a
TR
675
676test_must_fail () {
bbfe5302
LS
677 case "$1" in
678 ok=*)
679 _test_ok=${1#ok=}
680 shift
681 ;;
682 *)
683 _test_ok=
684 ;;
685 esac
a5bf824f 686 "$@" 2>&7
12a29b1a 687 exit_code=$?
bbfe5302
LS
688 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
689 then
03aa3783 690 echo >&4 "test_must_fail: command succeeded: $*"
12a29b1a 691 return 1
2472448c 692 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
8bf4becf
LS
693 then
694 return 0
bbfe5302
LS
695 elif test $exit_code -gt 129 && test $exit_code -le 192
696 then
03aa3783 697 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
12a29b1a 698 return 1
bbfe5302
LS
699 elif test $exit_code -eq 127
700 then
03aa3783 701 echo >&4 "test_must_fail: command not found: $*"
12a29b1a 702 return 1
bbfe5302
LS
703 elif test $exit_code -eq 126
704 then
03aa3783 705 echo >&4 "test_must_fail: valgrind error: $*"
eeb69131 706 return 1
12a29b1a
TR
707 fi
708 return 0
a5bf824f 709} 7>&2 2>&4
12a29b1a
TR
710
711# Similar to test_must_fail, but tolerates success, too. This is
712# meant to be used in contexts like:
713#
714# test_expect_success 'some command works without configuration' '
715# test_might_fail git config --unset all.configuration &&
716# do something
717# '
718#
719# Writing "git config --unset all.configuration || :" would be wrong,
720# because we want to notice if it fails due to segv.
12e31a6b
SG
721#
722# Accepts the same options as test_must_fail.
12a29b1a
TR
723
724test_might_fail () {
a5bf824f
SG
725 test_must_fail ok=success "$@" 2>&7
726} 7>&2 2>&4
12a29b1a
TR
727
728# Similar to test_must_fail and test_might_fail, but check that a
729# given command exited with a given exit code. Meant to be used as:
730#
731# test_expect_success 'Merge with d/f conflicts' '
732# test_expect_code 1 git merge "merge msg" B master
733# '
734
735test_expect_code () {
736 want_code=$1
737 shift
a5bf824f 738 "$@" 2>&7
12a29b1a
TR
739 exit_code=$?
740 if test $exit_code = $want_code
741 then
742 return 0
743 fi
744
03aa3783 745 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
12a29b1a 746 return 1
a5bf824f 747} 7>&2 2>&4
12a29b1a
TR
748
749# test_cmp is a helper function to compare actual and expected output.
750# You can use it like:
751#
752# test_expect_success 'foo works' '
753# echo expected >expected &&
754# foo >actual &&
755# test_cmp expected actual
756# '
757#
758# This could be written as either "cmp" or "diff -u", but:
759# - cmp's output is not nearly as easy to read as diff -u
760# - not all diff versions understand "-u"
761
762test_cmp() {
763 $GIT_TEST_CMP "$@"
764}
765
a5db0b77
NTND
766# Check that the given config key has the expected value.
767#
768# test_cmp_config [-C <dir>] <expected-value>
769# [<git-config-options>...] <config-key>
770#
771# for example to check that the value of core.bar is foo
772#
773# test_cmp_config foo core.bar
774#
775test_cmp_config() {
776 local GD &&
777 if test "$1" = "-C"
778 then
779 shift &&
780 GD="-C $1" &&
781 shift
782 fi &&
783 printf "%s\n" "$1" >expect.config &&
784 shift &&
785 git $GD config "$@" >actual.config &&
786 test_cmp expect.config actual.config
787}
788
b93e6e36
SK
789# test_cmp_bin - helper to compare binary files
790
791test_cmp_bin() {
792 cmp "$@"
793}
794
0f59128f
SG
795# Use this instead of test_cmp to compare files that contain expected and
796# actual output from git commands that can be translated. When running
6cdccfce 797# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
798# results.
799test_i18ncmp () {
6cdccfce 800 ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
0f59128f
SG
801}
802
803# Use this instead of "grep expected-string actual" to see if the
804# output from a git command that can be translated either contains an
805# expected string, or does not contain an unwanted one. When running
6cdccfce 806# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
807# results.
808test_i18ngrep () {
fd29d7b9
SG
809 eval "last_arg=\${$#}"
810
811 test -f "$last_arg" ||
165293af 812 BUG "test_i18ngrep requires a file to read as the last parameter"
fd29d7b9
SG
813
814 if test $# -lt 2 ||
815 { test "x!" = "x$1" && test $# -lt 3 ; }
816 then
165293af 817 BUG "too few parameters to test_i18ngrep"
fd29d7b9
SG
818 fi
819
6cdccfce 820 if test_have_prereq !C_LOCALE_OUTPUT
0f59128f 821 then
63b1a175
SG
822 # pretend success
823 return 0
824 fi
825
826 if test "x!" = "x$1"
0f59128f
SG
827 then
828 shift
63b1a175
SG
829 ! grep "$@" && return 0
830
03aa3783 831 echo >&4 "error: '! grep $@' did find a match in:"
0f59128f 832 else
63b1a175
SG
833 grep "$@" && return 0
834
03aa3783 835 echo >&4 "error: 'grep $@' didn't find a match in:"
0f59128f 836 fi
63b1a175
SG
837
838 if test -s "$last_arg"
839 then
03aa3783 840 cat >&4 "$last_arg"
63b1a175 841 else
03aa3783 842 echo >&4 "<File '$last_arg' is empty>"
63b1a175
SG
843 fi
844
845 return 1
0f59128f
SG
846}
847
8ad16524
JK
848# Call any command "$@" but be more verbose about its
849# failure. This is handy for commands like "test" which do
850# not output anything when they fail.
851verbose () {
852 "$@" && return 0
03aa3783 853 echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
8ad16524
JK
854 return 1
855}
856
ca8d148d
JH
857# Check if the file expected to be empty is indeed empty, and barfs
858# otherwise.
859
860test_must_be_empty () {
9eb23080
SG
861 test_path_is_file "$1" &&
862 if test -s "$1"
ca8d148d
JH
863 then
864 echo "'$1' is not empty, it contains:"
865 cat "$1"
866 return 1
867 fi
868}
869
5d77298d
MZ
870# Tests that its two parameters refer to the same revision
871test_cmp_rev () {
30d0b6dc
SG
872 if test $# != 2
873 then
874 error "bug in the test script: test_cmp_rev requires two revisions, but got $#"
875 else
876 local r1 r2
877 r1=$(git rev-parse --verify "$1") &&
878 r2=$(git rev-parse --verify "$2") &&
879 if test "$r1" != "$r2"
880 then
881 cat >&4 <<-EOF
882 error: two revisions point to different objects:
883 '$1': $r1
884 '$2': $r2
885 EOF
886 return 1
887 fi
888 fi
5d77298d
MZ
889}
890
ed33bd8f
JS
891# Compare paths respecting core.ignoreCase
892test_cmp_fspath () {
893 if test "x$1" = "x$2"
894 then
895 return 0
896 fi
897
898 if test true != "$(git config --get --type=bool core.ignorecase)"
899 then
900 return 1
901 fi
902
903 test "x$(echo "$1" | tr A-Z a-z)" = "x$(echo "$2" | tr A-Z a-z)"
904}
905
55672a39
JH
906# Print a sequence of integers in increasing order, either with
907# two arguments (start and end):
d17cf5f3 908#
55672a39
JH
909# test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
910#
911# or with one argument (end), in which case it starts counting
912# from 1.
d17cf5f3
MK
913
914test_seq () {
915 case $# in
916 1) set 1 "$@" ;;
917 2) ;;
165293af 918 *) BUG "not 1 or 2 parameters to test_seq" ;;
d17cf5f3 919 esac
4df43135
JH
920 test_seq_counter__=$1
921 while test "$test_seq_counter__" -le "$2"
922 do
923 echo "$test_seq_counter__"
924 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
925 done
d17cf5f3
MK
926}
927
12a29b1a
TR
928# This function can be used to schedule some commands to be run
929# unconditionally at the end of the test to restore sanity:
930#
931# test_expect_success 'test core.capslock' '
932# git config core.capslock true &&
933# test_when_finished "git config --unset core.capslock" &&
934# hello world
935# '
936#
937# That would be roughly equivalent to
938#
939# test_expect_success 'test core.capslock' '
940# git config core.capslock true &&
941# hello world
942# git config --unset core.capslock
943# '
944#
945# except that the greeting and config --unset must both succeed for
946# the test to pass.
947#
948# Note that under --immediate mode, no clean-up is done to help diagnose
949# what went wrong.
950
951test_when_finished () {
0968f12a
JK
952 # We cannot detect when we are in a subshell in general, but by
953 # doing so on Bash is better than nothing (the test will
954 # silently pass on other shells).
955 test "${BASH_SUBSHELL-0}" = 0 ||
165293af 956 BUG "test_when_finished does nothing in a subshell"
12a29b1a
TR
957 test_cleanup="{ $*
958 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
959}
960
900721e1
JS
961# This function can be used to schedule some commands to be run
962# unconditionally at the end of the test script, e.g. to stop a daemon:
963#
964# test_expect_success 'test git daemon' '
965# git daemon &
966# daemon_pid=$! &&
967# test_atexit 'kill $daemon_pid' &&
968# hello world
969# '
970#
971# The commands will be executed before the trash directory is removed,
972# i.e. the atexit commands will still be able to access any pidfiles or
973# socket files.
974#
975# Note that these commands will be run even when a test script run
976# with '--immediate' fails. Be careful with your atexit commands to
977# minimize any changes to the failed state.
978
979test_atexit () {
980 # We cannot detect when we are in a subshell in general, but by
981 # doing so on Bash is better than nothing (the test will
982 # silently pass on other shells).
983 test "${BASH_SUBSHELL-0}" = 0 ||
984 error "bug in test script: test_atexit does nothing in a subshell"
985 test_atexit_cleanup="{ $*
986 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
987}
988
12a29b1a
TR
989# Most tests can use the created repository, but some may need to create more.
990# Usage: test_create_repo <directory>
991test_create_repo () {
992 test "$#" = 1 ||
165293af 993 BUG "not 1 parameter to test-create-repo"
12a29b1a
TR
994 repo="$1"
995 mkdir -p "$repo"
996 (
997 cd "$repo" || error "Cannot setup test environment"
8abfdf44 998 "${GIT_TEST_INSTALLED:-$GIT_EXEC_PATH}/git$X" init \
3af4c715 999 "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
12a29b1a
TR
1000 error "cannot run git init -- have you built things yet?"
1001 mv .git/hooks .git/hooks-disabled
1002 ) || exit
1003}
9ce415d9
JS
1004
1005# This function helps on symlink challenged file systems when it is not
1006# important that the file system entry is a symbolic link.
1007# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1008# symbolic link entry y to the index.
1009
1010test_ln_s_add () {
1011 if test_have_prereq SYMLINKS
1012 then
1013 ln -s "$1" "$2" &&
1014 git update-index --add "$2"
1015 else
1016 printf '%s' "$1" >"$2" &&
1017 ln_s_obj=$(git hash-object -w "$2") &&
817d03e1
JS
1018 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1019 # pick up stat info from the file
1020 git update-index "$2"
9ce415d9
JS
1021 fi
1022}
4d715ac0 1023
ac9afcc3
MT
1024# This function writes out its parameters, one per line
1025test_write_lines () {
1026 printf "%s\n" "$@"
1027}
1028
a0e0ec9f 1029perl () {
a5bf824f
SG
1030 command "$PERL_PATH" "$@" 2>&7
1031} 7>&2 2>&4
a3a9cff0 1032
83d842dc
JK
1033# Is the value one of the various ways to spell a boolean true/false?
1034test_normalize_bool () {
1035 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
1036}
1037
1038# Given a variable $1, normalize the value of it to one of "true",
1039# "false", or "auto" and store the result to it.
1040#
1041# test_tristate GIT_TEST_HTTPD
1042#
1043# A variable set to an empty string is set to 'false'.
1044# A variable set to 'false' or 'auto' keeps its value.
1045# Anything else is set to 'true'.
1046# An unset variable defaults to 'auto'.
1047#
1048# The last rule is to allow people to set the variable to an empty
1049# string and export it to decline testing the particular feature
1050# for versions both before and after this change. We used to treat
1051# both unset and empty variable as a signal for "do not test" and
1052# took any non-empty string as "please test".
1053
1054test_tristate () {
1055 if eval "test x\"\${$1+isset}\" = xisset"
1056 then
1057 # explicitly set
1058 eval "
1059 case \"\$$1\" in
1060 '') $1=false ;;
1061 auto) ;;
1062 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
1063 esac
1064 "
1065 else
1066 eval "$1=auto"
1067 fi
1068}
1069
1070# Exit the test suite, either by skipping all remaining tests or by
1071# exiting with an error. If "$1" is "auto", we then we assume we were
1072# opportunistically trying to set up some tests and we skip. If it is
1073# "true", then we report a failure.
1074#
1075# The error/skip message should be given by $2.
1076#
1077test_skip_or_die () {
1078 case "$1" in
1079 auto)
1080 skip_all=$2
1081 test_done
1082 ;;
1083 true)
1084 error "$2"
1085 ;;
1086 *)
1087 error "BUG: test tristate is '$1' (real error: $2)"
1088 esac
1089}
1090
4d715ac0
JS
1091# The following mingw_* functions obey POSIX shell syntax, but are actually
1092# bash scripts, and are meant to be used only with bash on Windows.
1093
1094# A test_cmp function that treats LF and CRLF equal and avoids to fork
1095# diff when possible.
1096mingw_test_cmp () {
1097 # Read text into shell variables and compare them. If the results
1098 # are different, use regular diff to report the difference.
1099 local test_cmp_a= test_cmp_b=
1100
1101 # When text came from stdin (one argument is '-') we must feed it
1102 # to diff.
1103 local stdin_for_diff=
1104
1105 # Since it is difficult to detect the difference between an
1106 # empty input file and a failure to read the files, we go straight
1107 # to diff if one of the inputs is empty.
1108 if test -s "$1" && test -s "$2"
1109 then
1110 # regular case: both files non-empty
1111 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1112 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1113 elif test -s "$1" && test "$2" = -
1114 then
1115 # read 2nd file from stdin
1116 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1117 mingw_read_file_strip_cr_ test_cmp_b
1118 stdin_for_diff='<<<"$test_cmp_b"'
1119 elif test "$1" = - && test -s "$2"
1120 then
1121 # read 1st file from stdin
1122 mingw_read_file_strip_cr_ test_cmp_a
1123 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1124 stdin_for_diff='<<<"$test_cmp_a"'
1125 fi
1126 test -n "$test_cmp_a" &&
1127 test -n "$test_cmp_b" &&
1128 test "$test_cmp_a" = "$test_cmp_b" ||
1129 eval "diff -u \"\$@\" $stdin_for_diff"
1130}
1131
1132# $1 is the name of the shell variable to fill in
1133mingw_read_file_strip_cr_ () {
1134 # Read line-wise using LF as the line separator
1135 # and use IFS to strip CR.
1136 local line
1137 while :
1138 do
1139 if IFS=$'\r' read -r -d $'\n' line
1140 then
1141 # good
1142 line=$line$'\n'
1143 else
1144 # we get here at EOF, but also if the last line
1145 # was not terminated by LF; in the latter case,
1146 # some text was read
1147 if test -z "$line"
1148 then
1149 # EOF, really
1150 break
1151 fi
1152 fi
1153 eval "$1=\$$1\$line"
1154 done
1155}
d2554c72
JK
1156
1157# Like "env FOO=BAR some-program", but run inside a subshell, which means
1158# it also works for shell functions (though those functions cannot impact
1159# the environment outside of the test_env invocation).
1160test_env () {
1161 (
1162 while test $# -gt 0
1163 do
1164 case "$1" in
1165 *=*)
1166 eval "${1%%=*}=\${1#*=}"
1167 eval "export ${1%%=*}"
1168 shift
1169 ;;
1170 *)
a5bf824f 1171 "$@" 2>&7
d2554c72
JK
1172 exit
1173 ;;
1174 esac
1175 done
1176 )
a5bf824f 1177} 7>&2 2>&4
48860819 1178
9b67c994
JK
1179# Returns true if the numeric exit code in "$2" represents the expected signal
1180# in "$1". Signals should be given numerically.
1181test_match_signal () {
1182 if test "$2" = "$((128 + $1))"
1183 then
1184 # POSIX
1185 return 0
1186 elif test "$2" = "$((256 + $1))"
1187 then
1188 # ksh
1189 return 0
1190 fi
1191 return 1
1192}
39cadeec 1193
48860819
JK
1194# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1195test_copy_bytes () {
1196 perl -e '
1197 my $len = $ARGV[1];
1198 while ($len > 0) {
1199 my $s;
1200 my $nread = sysread(STDIN, $s, $len);
1201 die "cannot read: $!" unless defined($nread);
f7f6dc34 1202 last unless $nread;
48860819
JK
1203 print $s;
1204 $len -= $nread;
1205 }
1206 ' - "$1"
1207}
de95302a
JK
1208
1209# run "$@" inside a non-git directory
1210nongit () {
1211 test -d non-repo ||
1212 mkdir non-repo ||
1213 return 1
1214
1215 (
1216 GIT_CEILING_DIRECTORIES=$(pwd) &&
1217 export GIT_CEILING_DIRECTORIES &&
1218 cd non-repo &&
a5bf824f 1219 "$@" 2>&7
de95302a 1220 )
a5bf824f 1221} 7>&2 2>&4
4414a150
JK
1222
1223# convert stdin to pktline representation; note that empty input becomes an
1224# empty packet, not a flush packet (for that you can just print 0000 yourself).
1225packetize() {
1226 cat >packetize.tmp &&
1227 len=$(wc -c <packetize.tmp) &&
1228 printf '%04x%s' "$(($len + 4))" &&
1229 cat packetize.tmp &&
1230 rm -f packetize.tmp
1231}
1232
1233# Parse the input as a series of pktlines, writing the result to stdout.
1234# Sideband markers are removed automatically, and the output is routed to
1235# stderr if appropriate.
1236#
1237# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1238depacketize () {
1239 perl -e '
1240 while (read(STDIN, $len, 4) == 4) {
1241 if ($len eq "0000") {
1242 print "FLUSH\n";
1243 } else {
1244 read(STDIN, $buf, hex($len) - 4);
1245 $buf =~ s/\0/\\0/g;
1246 if ($buf =~ s/^[\x2\x3]//) {
1247 print STDERR $buf;
1248 } else {
1249 $buf =~ s/^\x1//;
1250 print $buf;
1251 }
1252 }
1253 }
1254 '
1255}
2c02b110 1256
5c07647d
TB
1257# Converts base-16 data into base-8. The output is given as a sequence of
1258# escaped octals, suitable for consumption by 'printf'.
1259hex2oct () {
1260 perl -ne 'printf "\\%03o", hex for /../g'
1261}
1262
2c02b110 1263# Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1264test_set_hash () {
1265 test_hash_algo="$1"
1266}
1267
1268# Detect the hash algorithm in use.
1269test_detect_hash () {
1270 # Currently we only support SHA-1, but in the future this function will
1271 # actually detect the algorithm in use.
1272 test_hash_algo='sha1'
1273}
1274
1275# Load common hash metadata and common placeholder object IDs for use with
1276# test_oid.
1277test_oid_init () {
1278 test -n "$test_hash_algo" || test_detect_hash &&
1279 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1280 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1281}
1282
1283# Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1284# and lines starting with "#" are ignored. Keys must be shell identifier
1285# characters.
1286#
1287# Examples:
1288# rawsz sha1:20
1289# rawsz sha256:32
1290test_oid_cache () {
1291 local tag rest k v &&
1292
1293 { test -n "$test_hash_algo" || test_detect_hash; } &&
1294 while read tag rest
1295 do
1296 case $tag in
1297 \#*)
1298 continue;;
1299 ?*)
1300 # non-empty
1301 ;;
1302 *)
1303 # blank line
1304 continue;;
1305 esac &&
1306
1307 k="${rest%:*}" &&
1308 v="${rest#*:}" &&
1309
1310 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1311 then
165293af 1312 BUG 'bad hash algorithm'
2c02b110 1313 fi &&
1314 eval "test_oid_${k}_$tag=\"\$v\""
1315 done
1316}
1317
1318# Look up a per-hash value based on a key ($1). The value must have been loaded
1319# by test_oid_init or test_oid_cache.
1320test_oid () {
1321 local var="test_oid_${test_hash_algo}_$1" &&
1322
1323 # If the variable is unset, we must be missing an entry for this
1324 # key-hash pair, so exit with an error.
1325 if eval "test -z \"\${$var+set}\""
1326 then
165293af 1327 BUG "undefined key '$1'"
2c02b110 1328 fi &&
1329 eval "printf '%s' \"\${$var}\""
1330}
fa840581
SG
1331
1332# Choose a port number based on the test script's number and store it in
1333# the given variable name, unless that variable already contains a number.
1334test_set_port () {
1335 local var=$1 port
1336
1337 if test $# -ne 1 || test -z "$var"
1338 then
1339 BUG "test_set_port requires a variable name"
1340 fi
1341
1342 eval port=\$$var
1343 case "$port" in
1344 "")
1345 # No port is set in the given env var, use the test
1346 # number as port number instead.
1347 # Remove not only the leading 't', but all leading zeros
1348 # as well, so the arithmetic below won't (mis)interpret
1349 # a test number like '0123' as an octal value.
1350 port=${this_test#${this_test%%[1-9]*}}
1351 if test "${port:-0}" -lt 1024
1352 then
1353 # root-only port, use a larger one instead.
1354 port=$(($port + 10000))
1355 fi
fa840581 1356 ;;
7d661e5e 1357 *[!0-9]*|0*)
fa840581
SG
1358 error >&7 "invalid port number: $port"
1359 ;;
1360 *)
1361 # The user has specified the port.
1362 ;;
1363 esac
fb7d1e3a
SG
1364
1365 # Make sure that parallel '--stress' test jobs get different
1366 # ports.
1367 port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1368 eval $var=$port
fa840581 1369}